/**
 * DefaultDispatcher.java
 *
 * $Id: DefaultDispatcher.java 1.1 2001/03/04 13:48:49 murata Exp $
 *
 * Created: Sun Feb 25 20:59:57 2001
 *
 * @author <a href="mailto:mura034@attglobal.net">MURATA Makoto (FAMILY Given)</a>
 * @version
 */

package org.iso_relax.dispatcher;

import java.util.HashSet;
import java.util.Stack;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class DefaultDispatcher extends DefaultHandler{

    int depth;
    Locator documentLocator;
    DefaultVerifier currentHandler;
    Stack handlerStack;
    Stack depthStack;
    
    public DefaultDispatcher () {
	depth = 0;
	documentLocator = null;
	currentHandler = new 
	    DefaultVerifier (new
			     String("http://www.xml.gr.jp/namespace/dummy"));
	handlerStack = new Stack ();
	depthStack = new Stack ();
    }

    public void setDocumentLocator (Locator locator)
    {
	documentLocator = locator;
    }

    public DefaultVerifier createHandler(String uri) {
	return new DefaultVerifier(uri);
    }

    public void startElement (String uri, String localName,
			      String qName, Attributes attributes)
	throws SAXException
    {
	if (!uri.equals(currentHandler.getNamespaceName())) {

	    HashSet candidates = currentHandler.startDummy(uri);

	    depthStack.push(new Integer(depth));
	    depth = 0;

	    handlerStack.push(currentHandler);
	    currentHandler = this.createHandler(uri);
	    currentHandler.setDocumentLocator(documentLocator);

	    currentHandler.startIsland(candidates);
	}

	depth++;

	currentHandler.startElement(localName, attributes);
    }

    public void endElement (String uri, String localName, String qName)
	throws SAXException
    {
	currentHandler.endElement(localName);

	depth --;

	if (depth == 0) {
	    HashSet results = currentHandler.endIsland();

	    depth = ((Integer)(depthStack.pop())).intValue();
	    currentHandler = (DefaultVerifier)(handlerStack.pop());

	    currentHandler.endDummy(results);
	}

    }

    public void characters (char ch[], int start, int length)
	throws SAXException
    {
	currentHandler.characters(ch, start, length);
    }

    public void ignorableWhitespace (char ch[], int start, int length)
	throws SAXException
    {
	currentHandler.ignorableWhitespace(ch, start, length);
    }

    public void processingInstruction (String target, String data)
	throws SAXException
    {
	currentHandler.processingInstruction (target, data);
    }
}// DefaultDispatcher
