/**
 * TestVerifier.java
 *
 * $Id: TestVerifier.java 1.1 2001/03/04 13:49:09 murata Exp murata $
 *
 * Created: Sun Feb 25 23:08:01 2001
 *
 * @author <a href="mailto:mura034@attglobal.net">MURATA Makoto (FAMILY Given)</a>
 * @version
 */

package org.iso_relax.dispatcher;

import java.io.StringWriter;
import java.util.HashSet;
import java.util.Iterator;
import org.xml.sax.*;

public class TestVerifier extends DefaultVerifier {

    StringWriter stringWriter;

    public TestVerifier (String uri)
    {
	super(uri);
	stringWriter = new StringWriter ();
    }

    public void startIsland (HashSet candidates)
    {
	//	System.out.println("Start Island");

	stringWriter.write("\n*Island start: ");
	stringWriter.write(namespaceName);
	Iterator iterator = candidates.iterator();

	while (iterator.hasNext()) {
	    String nextCandidate = (String)(iterator.next());
	    stringWriter.write(nextCandidate);
	    stringWriter.write(" ");
	}
	stringWriter.write("\n");
    }

    public HashSet endIsland ()
    {
	//	System.out.println("End Island");

	stringWriter.write("\n*Island end\n");
	System.out.print(stringWriter.toString());
	return new HashSet();
    }

    public HashSet startDummy (String subordinateNamespaceName)
    {
	//	System.out.println("Start dummy");

	stringWriter.write("<dummy namespaceName=\"");
	stringWriter.write(subordinateNamespaceName);
	stringWriter.write(" xmlns=\"http://www.xml.gr.jp/xmlns/dummy\"/>");
	return new HashSet();
    }

    public void endDummy (HashSet results)
    {
	//stringWriter.write("</dummy>");
    }
    public void startElement (String localName, Attributes attributes)
	throws SAXException
    {
	//	System.out.println(localName);

	stringWriter.write("<");
	stringWriter.write(localName);
	for (int i=0; i < attributes.getLength(); i++) {
	    stringWriter.write(" ");
	    String uri = attributes.getURI(i);
	    String localAttName = attributes.getLocalName(i);
            String value =attributes.getValue(i);
	    if (uri != "") {
		stringWriter.write("{");
		stringWriter.write(uri);
		stringWriter.write("}");
	    }
	    stringWriter.write(localAttName);
	    stringWriter.write("=\"");
	    stringWriter.write(value);
	    stringWriter.write("\"");
	}
	stringWriter.write(">");
    }

    public void endElement (String localName)
	throws SAXException
    {
	//	System.out.println(localName);

	stringWriter.write("</");
	stringWriter.write(localName);
	stringWriter.write(">");
    }

    public void characters (char ch[], int start, int length)
	throws SAXException
    {
	stringWriter.write(ch, start, length);
    }

    public void ignorableWhitespace (char ch[], int start, int length)
	throws SAXException
    {
	stringWriter.write(ch, start, length);
    }

    public void processingInstruction (String target, String data)
	throws SAXException
    {
	stringWriter.write("<?");
	stringWriter.write(target);
	stringWriter.write("?>\n");
    }

    public void skippedEntity (String name)
	throws SAXException
    {
	stringWriter.write("Skipped entity");
	stringWriter.write(name);
	stringWriter.write("\n");
    }

   
}// TestVerifier
